#importing GUI
from wxPython import wx
from wxPython import ogl

#importing parent
from EntityView import EntityView
#importing dialogs
from Dialogs import PhysicalEntityDialog

class PhysicalEntityView(EntityView):
   def BuildFromScratch(self, dc, entity, x, y, w, h):
      #declaring consts and vars
      HEADER_REGION = 0
      PROPS_REGION = 1
      HEADER_HEIGHT = 30.0
      LINE_HEIGHT = 12.0

      regions = [None, None]

      #calculating height
      lines = len(entity.propertylinks)
      lines_height = (lines + 1) * LINE_HEIGHT  #chars like "y" grow under
                                                #the bottom of the latest line,
                                                #therefore we need to add 1
                                                #more line than really required
      full_height = HEADER_HEIGHT + lines_height
      
      #setting size
      if(h == 0):
         h = full_height
         self.SetSize(w, h)
      #adding regions
      if (len(self.GetRegions()) == 0):
         regions[HEADER_REGION] = ogl.wxShapeRegion()
         self.AddRegion(regions[HEADER_REGION])
         regions[PROPS_REGION] = ogl.wxShapeRegion()
         self.AddRegion(regions[PROPS_REGION])
      else:
          regions[HEADER_REGION] = self.GetRegions()[HEADER_REGION]
          regions[PROPS_REGION] = self.GetRegions()[PROPS_REGION]


      #setting header region
      regions[HEADER_REGION].SetProportions(1.0, HEADER_HEIGHT/full_height)
      self.SetFormatMode(ogl.FORMAT_CENTRE_VERT, HEADER_REGION)
      self.FormatText(dc, entity.name, HEADER_REGION)
      self.SetX(x)
      self.SetY(y)

      #adding properties region
      regions[PROPS_REGION].SetProportions(1.0, lines_height/full_height)
      s = ""
      for i in entity.propertylinks:
         flg = 0
         s = s + i.localname + ":" + i.property.datatype.name 
         if(i.property.datatype.size1 != None):
             s = s + "("+str(i.property.datatype.size1)
             flg = 1
         if(i.property.datatype.size2 != None):
             s = s + ","+str(i.property.datatype.size2)
         if(flg == 1):
             s = s + ")"
         s = s + "\n"
      self.SetFormatMode(ogl.FORMAT_NONE, PROPS_REGION)
      self.FormatText(dc, s, PROPS_REGION)

   def Edit(self):
      a = PhysicalEntityDialog(self.modelview, -1, "Edit entity", self.entity, self.GetCanvas().model)
      a.ShowModal()
      a.Destroy()
      self.BuildFromScratch(self.dc, self.entity, self.GetX(), self.GetY(), self.GetWidth(), 0)
      self.Recompute()
      self.modelview.Redraw(self.dc)
