from Objects import PhysicalModel
from Objects import PhysicalEntity
from Objects import PhysicalProperty
from Objects import PhysicalPropertyLink
from Objects import PhysicalRelation

class SaveSqlModel (object) :
   __slots__ = ('filename')
   def __init__(self, fname):
      self.filename = fname

   def save(self, model, view) :
      #saving model
      f = file(self.filename, 'w+')
      txt = self.SavePhysicalModel(model)
      f.write(txt)
      f.close()

   def SavePhysicalModel(self, model):
      txt = ""
      for i in model.entities:
         txt = txt + self.SavePhysicalEntity(i)
      for i in model.relations:
         txt = txt + self.SavePhysicalRelation(i)
      return txt

   def SavePhysicalEntity(self, entity):
      t = "create table " + entity.name + "( \n"
      l=len(entity.propertylinks)
      n = 0
      for i in entity.propertylinks:
          n=n+1
          t = t + self.SavePhysicalPropertyLink(i)
          if(n==l):
              t=t+"\n"
          else:
              t=t+",\n"
      t = t + ");\n"
      t=t+self.SavePrimaryKey(entity)
      return t
   def SavePrimaryKey(self, entity):
       pk = []
       txt=""
       for i in entity.propertylinks:
           if(i.primarykey == 1):
               pk.append(str(i.localname))
       if(len(pk)>0):
           s = str(pk).replace("\'","")
           txt="alter table "+entity.name+" add primary key (" + s[1:len(s)-1] + ");\n"
       return txt

   def SavePhysicalPropertyLink(self, proplink):
       t = "\t" + proplink.localname + " " + proplink.property.datatype.name
       if proplink.property.datatype.size1 != None:
           t=t + "("+str(proplink.property.datatype.size1)
           if proplink.property.datatype.size2 != None:
               t=t+", "+str(proplink.property.datatype.size2)
           t=t+")"
       if(proplink.primarykey == 1):
           t = t + " not null"
       elif (proplink.notnull == 1):
           t = t + " not null"
           if(proplink.unique == 1):
               t = t + " unique"
       else:
           if(proplink.unique == 1):
               t = t + " unique"
       return t

   def SavePhysicalRelation(self, r):
       t="alter table " + r.entities[1].name + " add foreign key " + " ("
       props = []
       for i in r.properties:
           props.append(str(r.entities[1].GetPropertyLocalName(i.name)))
       s = str(props).replace("\'","")
       t=t+s[1:len(s)-1] +") references " + r.entities[0].name + " ("
       props = []
       for i in r.properties:
           props.append(str(r.entities[0].GetPropertyLocalName(i.name)))
       s = str(props).replace("\'","")
       t = t=t+s[1:len(s)-1] +");\n"
       return t
